| garciadeblas | 93c6131 | 2016-09-28 15:12:48 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 2 | # |
| 3 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 4 | # you may not use this file except in compliance with the License. |
| 5 | # You may obtain a copy of the License at |
| 6 | # |
| 7 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 8 | # |
| 9 | # Unless required by applicable law or agreed to in writing, software |
| 10 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 11 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 12 | # See the License for the specific language governing permissions and |
| 13 | # limitations under the License. |
| 14 | # |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 15 | REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian |
| garciadeblas | 7bcadc5 | 2020-02-02 22:40:15 +0100 | [diff] [blame] | 16 | RELEASE=ReleaseSEVEN |
| 17 | REPOSITORY=stable |
| 18 | DOCKER_TAG=7 |
| garciadeblas | 93c6131 | 2016-09-28 15:12:48 +0200 | [diff] [blame] | 19 | |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 20 | function usage(){ |
| 21 | echo -e "usage: $0 [OPTIONS]" |
| 22 | echo -e "Install OSM from binaries or source code (by default, from binaries)" |
| 23 | echo -e " OPTIONS" |
| 24 | echo -e " -r <repo>: use specified repository name for osm packages" |
| 25 | echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)" |
| 26 | echo -e " -u <repo base>: use specified repository url for osm packages" |
| 27 | echo -e " -k <repo key>: use specified repository public key url" |
| 28 | echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag" |
| 29 | echo -e " -b master (main dev branch)" |
| 30 | echo -e " -b v2.0 (v2.0 branch)" |
| 31 | echo -e " -b tags/v1.1.0 (a specific tag)" |
| 32 | echo -e " ..." |
| 33 | echo -e " -s <stack name> user defined stack name, default is osm" |
| 34 | echo -e " -H <VCA host> use specific juju host controller IP" |
| 35 | echo -e " -S <VCA secret> use VCA/juju secret key" |
| 36 | echo -e " -P <VCA pubkey> use VCA/juju public key file" |
| 37 | echo -e " -C <VCA cacert> use VCA/juju CA certificate file" |
| 38 | echo -e " -A <VCA apiproxy> use VCA/juju API proxy" |
| 39 | echo -e " --vimemu: additionally deploy the VIM emulator as a docker container" |
| 40 | echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging" |
| 41 | echo -e " --pm_stack: additionally deploy a Prometheus+Grafana stack for performance monitoring (PM)" |
| 42 | echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, KEYSTONE-DB, NONE)" |
| 43 | echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, pm_stack)" |
| 44 | echo -e " -D <devops path> use local devops installation path" |
| 45 | echo -e " -w <work dir> Location to store runtime installation" |
| 46 | echo -e " -t <docker tag> specify osm docker tag (default is latest)" |
| 47 | echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)" |
| 48 | echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)" |
| 49 | echo -e " --nojuju: do not juju, assumes already installed" |
| 50 | echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)" |
| 51 | echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)" |
| 52 | echo -e " --nohostclient: do not install the osmclient" |
| 53 | echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules" |
| 54 | echo -e " --source: install OSM from source code using the latest stable tag" |
| 55 | echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch" |
| 56 | echo -e " --soui: install classic build of OSM (Rel THREE v3.1, based on LXD containers, with SO and UI)" |
| 57 | echo -e " --lxdimages: (only for Rel THREE with --soui) download lxd images from OSM repository instead of creating them from scratch" |
| 58 | echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano" |
| 59 | echo -e " -l <lxd_repo>: (only for Rel THREE with --soui) use specified repository url for lxd images" |
| 60 | echo -e " -p <path>: (only for Rel THREE with --soui) use specified repository path for lxd images" |
| 61 | echo -e " --nat: (only for Rel THREE with --soui) install only NAT rules" |
| 62 | echo -e " --noconfigure: (only for Rel THREE with --soui) DO NOT install osmclient, DO NOT install NAT rules, DO NOT configure modules" |
| 63 | echo -e " --showopts: print chosen options and exit (only for debugging)" |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 64 | #echo -e " --clean_volumes To clear all the mounted volumes from docker swarm" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 65 | echo -e " -y: do not prompt for confirmation, assumes yes" |
| 66 | echo -e " -h / --help: print this help" |
| 67 | } |
| 68 | |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 69 | add_repo() { |
| 70 | REPO_CHECK="^$1" |
| 71 | grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1 |
| 72 | if [ $? -ne 0 ] |
| 73 | then |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 74 | need_packages_lw="software-properties-common apt-transport-https" |
| 75 | echo -e "Checking required packages: $need_packages_lw" |
| 76 | dpkg -l $need_packages_lw &>/dev/null \ |
| 77 | || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \ |
| 78 | || sudo apt-get -q update \ |
| Mike Marchetti | 3412418 | 2018-10-16 08:22:30 -0400 | [diff] [blame] | 79 | || ! echo "failed to run apt-get update" \ |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 80 | || exit 1 |
| 81 | dpkg -l $need_packages_lw &>/dev/null \ |
| 82 | || ! echo -e "Installing $need_packages_lw requires root privileges." \ |
| 83 | || sudo apt-get install -y $need_packages_lw \ |
| Mike Marchetti | 3412418 | 2018-10-16 08:22:30 -0400 | [diff] [blame] | 84 | || ! echo "failed to install $need_packages_lw" \ |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 85 | || exit 1 |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 86 | wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add - |
| 87 | sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update |
| garciadeblas | 429b9f8 | 2018-03-20 02:09:44 +0100 | [diff] [blame] | 88 | return 0 |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 89 | fi |
| 90 | |
| 91 | return 1 |
| garciadeblas | 55490d4 | 2016-10-29 14:22:03 +0200 | [diff] [blame] | 92 | } |
| 93 | |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 94 | clean_old_repo() { |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 95 | dpkg -s 'osm-devops' &> /dev/null |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 96 | if [ $? -eq 0 ]; then |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 97 | # Clean the previous repos that might exist |
| 98 | sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list |
| 99 | fi |
| 100 | } |
| 101 | |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 102 | while getopts ":b:r:c:k:u:R:l:p:D:o:m:H:S:s:w:t:U:P:A:-: hy" o; do |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 103 | case "${o}" in |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 104 | r) |
| 105 | REPOSITORY="${OPTARG}" |
| 106 | ;; |
| 107 | R) |
| 108 | RELEASE="${OPTARG}" |
| 109 | ;; |
| 110 | u) |
| 111 | REPOSITORY_BASE="${OPTARG}" |
| 112 | ;; |
| 113 | t) |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 114 | DOCKER_TAG="${OPTARG}" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 115 | ;; |
| garciadeblas | 72399e3 | 2019-11-22 10:09:40 +0100 | [diff] [blame] | 116 | -) |
| 117 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| garciadeblas | 72399e3 | 2019-11-22 10:09:40 +0100 | [diff] [blame] | 118 | ;; |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 119 | :) |
| 120 | echo "Option -$OPTARG requires an argument" >&2 |
| 121 | usage && exit 1 |
| 122 | ;; |
| 123 | \?) |
| 124 | echo -e "Invalid option: '-$OPTARG'\n" >&2 |
| 125 | usage && exit 1 |
| 126 | ;; |
| 127 | h) |
| 128 | usage && exit 0 |
| 129 | ;; |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 130 | *) |
| 131 | ;; |
| 132 | esac |
| 133 | done |
| 134 | |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 135 | clean_old_repo |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 136 | add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops" |
| garciadeblas | 35f96ae | 2018-05-23 12:33:36 +0200 | [diff] [blame] | 137 | sudo DEBIAN_FRONTEND=noninteractive apt-get -q update |
| 138 | sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops |
| garciadeblas | a5e6607 | 2019-05-29 12:23:22 +0200 | [diff] [blame] | 139 | /usr/share/osm-devops/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@" |